import React from 'react';
export var ApiContext = React.createContext({});
export var ApiProvider = ApiContext.Provider;
import HttpClient from '../classes/HttpClient';
var useState = React.useState;
/**
 * This component provides the HTTP client instance to all application
 * @author Alejandro <alejandro.devop@gmail.com>
 * @version 1.0.0
 * @param children
 * @param config
 * @param ClientLogger
 * @constructor
 */
var ApiClient = function (_a) {
    var children = _a.children, config = _a.config, dataProcessor = _a.dataProcessor, ClientLogger = _a.ClientLogger;
    var _b = config || {}, auth = _b.auth, debug = _b.debug, endpoints = _b.endpoints, server = _b.server, log = _b.log, strictJSON = _b.strictJSON;
    var _c = useState([]), requestsLog = _c[0], setRequestsLog = _c[1];
    var client = new HttpClient({
        dataProcessor: dataProcessor,
        strictJSON: strictJSON,
        server: server,
        endpoints: endpoints,
        debug: debug,
        log: log,
        auth: auth,
        onRequestDone: function (_a) {
            var loggedRequests = _a.loggedRequests;
            if (log) {
                setRequestsLog(loggedRequests);
            }
        }
    });
    var setClientProperties = function (properties) {
        client.setProperties(properties);
    };
    return (React.createElement(ApiProvider, { value: { client: client, dataProcessor: dataProcessor, setClientProperties: setClientProperties, strictJSON: strictJSON } },
        children,
        log && ClientLogger && React.createElement(ClientLogger, { requests: requestsLog })));
};
export default ApiClient;
//# sourceMappingURL=ApiClient.js.map